import { METADATA_INFO } from "../metadataInfo";
import * as _ from "lodash";
import BaseMetadataRetriever from "./baseMetadataRetriever";
import MetadataFiles from "../metadataFiles";
const QUERY = "SELECT Id,  Name, SobjectName, DurableId, IsCustom, Label FROM TabDefinition ";
export default class TabDefinitionRetriever extends BaseMetadataRetriever {
    constructor(org) {
        super(org, true);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!TabDefinitionRetriever.instance) {
            TabDefinitionRetriever.instance = new TabDefinitionRetriever(org);
        }
        return TabDefinitionRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            super.setQuery(QUERY);
            let tabs = await super.getObjects();
            this.data = tabs;
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getTabs() {
        return await this.getObjects();
    }
    async tabExists(tab) {
        let found = false;
        //Look first in project files
        if (!_.isNil(METADATA_INFO.CustomTab.components)) {
            found = METADATA_INFO.CustomTab.components.includes(tab);
        }
        if (!found && !MetadataFiles.sourceOnly) {
            //not found, check on the org
            let tabs = await this.getTabs();
            let foundTab = tabs.find(t => {
                return t.Name === tab;
            });
            found = !_.isNil(foundTab);
        }
        return found;
    }
}
//# sourceMappingURL=tabDefinitionRetriever.js.map