import { LoggerLevel } from "@salesforce/core";
import { SFPowerkit } from "../../../sfpowerkit";
import ScratchOrgUtils from "./scratchOrgUtils";
export default class PoolFetchImpl {
    constructor(hubOrg, apiversion, tag, mypool, allScratchOrgs) {
        this.hubOrg = hubOrg;
        this.apiversion = apiversion;
        this.tag = tag;
        this.mypool = mypool;
        this.allScratchOrgs = allScratchOrgs;
    }
    async execute() {
        const results = (await ScratchOrgUtils.getScratchOrgsByTag(this.tag, this.hubOrg, this.mypool, !this.allScratchOrgs));
        let scratchOrgToDelete = new Array();
        if (results.records.length > 0) {
            SFPowerkit.log(`${this.tag} pool has ${results.records.length} Scratch orgs available`, LoggerLevel.TRACE);
            for (let element of results.records) {
                let soDetail = {};
                soDetail.tag = element.Pooltag__c;
                soDetail.orgId = element.ScratchOrg;
                soDetail.loginURL = element.LoginUrl;
                soDetail.username = element.SignupUsername;
                soDetail.password = element.Password__c;
                soDetail.expityDate = element.ExpirationDate;
                soDetail.status = element.Allocation_status__c
                    ? "In use"
                    : "Not in use";
                scratchOrgToDelete.push(soDetail);
            }
        }
        return scratchOrgToDelete;
    }
}
//# sourceMappingURL=poolListImpl.js.map